import type { GlobalRegistry } from '../../../../2_generator/globalRegistry.js';
import type { Codec } from './codec.js';
export { JavaScriptScalarCodecs } from './nativeScalarCodecs.js';
export declare const ScalarKind = "Scalar";
export type ScalarKind = typeof ScalarKind;
export type StandardScalarRuntimeTypes = boolean | number | string;
export declare const create: <$Name extends string, $Decoded, $Encoded extends StandardScalarRuntimeTypes>(name: $Name, codec: {
    encode: (value: $Decoded) => $Encoded;
    decode: (value: $Encoded) => $Decoded;
}) => Scalar<$Name, $Decoded, $Encoded>;
export declare const scalar: <$Name extends string, $Codec extends Codec<any, any>>(name: $Name, codec: $Codec) => Scalar<$Name, $Codec>;
export interface Scalar<$Name extends string = string, $Decoded = unknown, $Encoded extends StandardScalarRuntimeTypes = StandardScalarRuntimeTypes> {
    kind: ScalarKind;
    name: $Name;
    codec: Codec<$Decoded, $Encoded>;
}
export declare const String: Scalar<"String", string, string>;
export declare const ID: Scalar<"ID", string, string>;
export declare const Int: Scalar<"Int", number, number>;
export declare const Float: Scalar<"Float", number, number>;
export declare const Boolean: Scalar<"Boolean", boolean, boolean>;
export type ID = typeof ID;
export type String = typeof String;
export type Int = typeof Int;
export type Boolean = typeof Boolean;
export type Float = typeof Float;
export declare const Scalars: {
    String: Scalar<"String", string, string>;
    ID: Scalar<"ID", string, string>;
    Int: Scalar<"Int", number, number>;
    Float: Scalar<"Float", number, number>;
    Boolean: Scalar<"Boolean", boolean, boolean>;
};
export type Any = String | Int | Boolean | ID | Float | Values<GlobalRegistry.Schemas[keyof GlobalRegistry.Schemas]['customScalars']>;
type Values<T> = T extends any ? keyof T extends never ? never : T[keyof T] : never;
//# sourceMappingURL=Scalar.d.ts.map