export const readConfigErrorCategoryOutputChannel = (config, errorCategory) => {
    if (config.output.errors[errorCategory] === `default`) {
        return config.output.defaults.errorChannel;
    }
    return config.output.errors[errorCategory];
};
export const traditionalGraphqlOutput = {
    defaults: { errorChannel: `throw` },
    envelope: { enabled: true, errors: { execution: true, other: false, schema: false } },
    errors: { execution: `default`, other: `default`, schema: false },
};
export const traditionalGraphqlOutputThrowing = {
    ...traditionalGraphqlOutput,
    envelope: {
        ...traditionalGraphqlOutput.envelope,
        errors: {
            ...traditionalGraphqlOutput.envelope.errors,
            execution: false,
        },
    },
};
export const isContextConfigTraditionalGraphQLOutput = (config) => {
    return config.output.envelope.enabled && config.output.envelope.errors.execution
        && !config.output.envelope.errors.other && !config.output.envelope.errors.schema;
};
export const outputConfigDefault = {
    defaults: {
        errorChannel: `throw`,
    },
    envelope: {
        enabled: false,
        errors: {
            execution: true,
            other: false,
            schema: false,
        },
    },
    errors: {
        execution: `default`,
        other: `default`,
        schema: false,
    },
};
//# sourceMappingURL=Config.js.map