import { Transport } from '../../5_core/types.js';
import { outputConfigDefault } from './Config.js';
export const inputToConfig = (input) => {
    const envelopeLonghand = typeof input.output?.envelope === `object`
        ? { enabled: true, ...input.output.envelope }
        : typeof input.output?.envelope === `boolean`
            ? { enabled: input.output.envelope }
            : undefined;
    return {
        transport: inferTransport(input),
        output: {
            defaults: {
                // @ts-expect-error conditional type
                errorChannel: input.output?.defaults?.errorChannel ?? outputConfigDefault.defaults.errorChannel,
            },
            envelope: {
                // @ts-expect-error conditional type
                enabled: envelopeLonghand?.enabled ?? outputConfigDefault.envelope.enabled,
                errors: {
                    // @ts-expect-error conditional type
                    execution: envelopeLonghand?.errors?.execution ?? outputConfigDefault.envelope.errors.execution,
                    // @ts-expect-error conditional type
                    other: envelopeLonghand?.errors?.other ?? outputConfigDefault.envelope.errors.other,
                    // @ts-expect-error conditional type
                    // eslint-disable-next-line
                    schema: envelopeLonghand?.errors?.schema ?? outputConfigDefault.envelope.errors.schema,
                },
            },
            errors: {
                // @ts-expect-error conditional type
                execution: input.output?.errors?.execution ?? outputConfigDefault.errors.execution,
                // @ts-expect-error conditional type
                other: input.output?.errors?.other ?? outputConfigDefault.errors.other,
                // @ts-expect-error conditional type
                // eslint-disable-next-line
                schema: input.output?.errors?.schema ?? outputConfigDefault.errors.schema,
            },
        },
    };
};
const inferTransport = (input) => {
    // @ts-expect-error conditional type
    return input.schema instanceof URL || typeof input.schema === `string` ? Transport.http : Transport.memory;
};
//# sourceMappingURL=Input.js.map