import { beforeEach, vi } from 'vitest';
import { Anyware } from './__.js';
export const initialInput = { value: `initial` };
export const createAnyware = () => {
    const a = {
        slots: {
            append: vi.fn().mockImplementation((hookName) => {
                return hookName;
            }),
            appendExtra: vi.fn().mockImplementation(() => {
                return ``;
            }),
        },
        run: vi.fn().mockImplementation(({ input, slots }) => {
            const extra = slots.appendExtra(`a`);
            return { value: input.value + `+` + slots.append(`a`) + extra };
        }),
    };
    const b = {
        slots: {
            append: vi.fn().mockImplementation((hookName) => {
                return hookName;
            }),
            appendExtra: vi.fn().mockImplementation(() => {
                return ``;
            }),
        },
        run: vi.fn().mockImplementation(({ input, slots }) => {
            const extra = slots.appendExtra(`b`);
            return { value: input.value + `+` + slots.append(`b`) + extra };
        }),
    };
    return Anyware.create({
        hookNamesOrderedBySequence: [`a`, `b`],
        hooks: { a, b },
    });
};
// @ts-expect-error
export let anyware = null;
export let core;
beforeEach(() => {
    // @ts-expect-error mock types not tracked by Anyware
    anyware = createAnyware();
    core = anyware.core;
});
export const runWithOptions = (options = {}) => async (...extensions) => {
    const result = await anyware.run({
        initialInput,
        // @ts-expect-error fixme
        extensions,
        options,
    });
    return result;
};
export const run = async (...extensions) => runWithOptions({})(...extensions);
export const oops = new Error(`oops`);
//# sourceMappingURL=specHelpers.js.map